FEM FemMesh2Mesh/ro: Difference between revisions

From FreeCAD Documentation
(Created page with "==Descriere==")
(Created page with "Acest instrument transformă suprafețele elementelor 3D dintr-o plasă FEM selectată în plasă. Pe plan intern, se selectează fașetele elementului FEM din plasă care sun...")
Line 5: Line 5:
==Descriere==
==Descriere==


Acest instrument transformă suprafețele elementelor 3D dintr-o plasă FEM selectată în plasă. Pe plan intern, se selectează fașetele elementului FEM din plasă care sunt unice (nu sunt împărțite de două elemente) și le utilizează pentru a crea fașete ale unei rețele. Opțional, aceasta permite crearea unei rețele deformate cauzate de acțiunea forțelor definite. Acest lucru se face prin adăugarea deplasării rezultatelor FEM la nodurile de plasă.
This tool converts surfaces of 3D elements of a selected FEM mesh to mesh. Internally it picks FEM mesh element faces which are unique (not shared by two elements) and uses them to create faces of a mesh. Optionally it allows to create a deformed mesh caused by the action of the defined forces. This is done by adding the displacement of the FEM results to the mesh nodes.


Two dimensional elements from the FEM mesh are not taken into account. If you need to convert them, you can use a python script below.
Two dimensional elements from the FEM mesh are not taken into account. If you need to convert them, you can use a python script below.

Revision as of 18:14, 11 November 2018

FEM FemMesh2Mesh

poziția meniului
Mesh → FEM mesh to mesh
Ateliere
FEM
scurtătură
nici unul
Prezentat în versiune
-
A se vedea, de asemenea,
FEM tutorial

Descriere

Acest instrument transformă suprafețele elementelor 3D dintr-o plasă FEM selectată în plasă. Pe plan intern, se selectează fașetele elementului FEM din plasă care sunt unice (nu sunt împărțite de două elemente) și le utilizează pentru a crea fașete ale unei rețele. Opțional, aceasta permite crearea unei rețele deformate cauzate de acțiunea forțelor definite. Acest lucru se face prin adăugarea deplasării rezultatelor FEM la nodurile de plasă.

Two dimensional elements from the FEM mesh are not taken into account. If you need to convert them, you can use a python script below.

How to use

  1. Select a FEM mesh object (optionally select additionally the FEM results)
  2. Press the FEM mesh to mesh button

Scripting

Example:

  • Load FreeCAD's 3D FEM example from the Start Workbench and run the following code
femmesh_obj = App.ActiveDocument.getObject("Result_mesh").FemMesh
result = App.ActiveDocument.getObject("CalculiX_static_results")
import femmesh.femmesh2mesh
out_mesh = femmesh.femmesh2mesh.femmesh_2_mesh(femmesh_obj, result)
import Mesh
Mesh.show(Mesh.Mesh(out_mesh))

Converting 2D elements

Select a mesh and run the following python script

import Mesh

def extend_by_triangle(i, j, k):
    triangle = [input_mesh.getNodeById(element_nodes[i]),
                input_mesh.getNodeById(element_nodes[j]),
                input_mesh.getNodeById(element_nodes[k])]
    return output_mesh.extend(triangle) 

selection = FreeCADGui.Selection.getSelection()
input_mesh = App.ActiveDocument.getObject(selection[0].Name).FemMesh
output_mesh = []
for element in input_mesh.Faces:
    element_nodes = input_mesh.getElementNodes(element)
    if len(element_nodes) in [3, 6]:  # tria3 or tria6 (ignoring mid-nodes)
        extend_by_triangle(0, 1, 2)
    elif len(element_nodes) in [4, 8]:  # quad4 or quad8 (ignoring mid-nodes)
        extend_by_triangle(0, 1, 2)
        extend_by_triangle(2, 3, 0)

obj = Mesh.Mesh(output_mesh)
Mesh.show(obj)